Index: trunk/tools/arch_info/arch_classes.py
===================================================================
--- trunk/tools/arch_info/arch_classes.py	(revision 1)
+++ trunk/tools/arch_info/arch_classes.py	(revision 6)
@@ -13,5 +13,5 @@
 #  It handle 4 types of objects: clusters, cores, devices and irqs.
 #  - The number of cluster is variable (can be one). 
-#  - The cluster topology can be a 2D mesh or a simpla array.
+#  - The cluster topology can be a 2D mesh or a simple 1D array.
 #  - The number of cores per cluster is variable (can be zero). 
 #  - The number of addressable devices per cluster is variable.
@@ -41,53 +41,43 @@
 #########################################################################################
 # These arrays define the supported types of peripherals.
-# They must be kept consistent with values defined in file arch_info.h.
+# They must be kept consistent with values defined in files arch_info.h & device.h.
 #########################################################################################
 
 DEVICE_TYPES_STR = [
-    'RAM',             # 0
-    'DMA',             # 1
-    'FBF',             # 1
-    'IOB',             # 3
-    'IOC_BDV',         # 4
-    'IOC_HBA',         # 5
-    'IOC_SDC',         # 6
-    'IOC_SPI',         # 7
-    'IOC_RDK',         # 8
-    'MMC',             # 9
-    'MWR_CPY',         # 10
-    'MWR_GCD',         # 11
-    'MWR_DCT',         # 12
-    'NIC',             # 13
-    'ROM',             # 14
-    'SIM',             # 15
-    'TIM',             # 16
-    'TTY',             # 17
-    'XCU',             # 18
-    'PIC',             # 19
-    'CMA',             # 20
+    'RAM_SCL',         # 0.0
+    'ROM_SCL',         # 1.0
+    'FBF_SCL',         # 2.0
+    'IOB_TSR',         # 3.0
+    'IOC_BDV',         # 4.0
+    'IOC_HBA',         # 4.1
+    'IOC_SDC',         # 4.2
+    'IOC_SPI',         # 4.3
+    'IOC_RDK',         # 4.4
+    'MMC_TSR',         # 5.0
+    'DMA_SCL',         # 6.0
+    'NIC_CBF',         # 7.0
+    'TIM_SCL',         # 8.0
+    'TXT_TTY',         # 9.0
+    'ICU_XCU',         # A.0
+    'PIC_TSR',         # B.0
     ]
    
 DEVICE_TYPES_INT = [
-    0x00000000,        # 0
-    0x00010000,        # 1
-    0x00020000,        # 1
-    0x00030000,        # 3
-    0x00040000,        # 4
-    0x00040001,        # 5
-    0x00040002,        # 6
-    0x00040003,        # 7
-    0x00040004,        # 8
-    0x00050000,        # 9
-    0x00060000,        # 10
-    0x00060001,        # 11
-    0x00060002,        # 12
-    0x00070000,        # 13
-    0x00080000,        # 14
-    0x00090000,        # 15
-    0x000A0000,        # 16
-    0x000B0000,        # 17
-    0x000C0000,        # 18
-    0x000D0000,        # 19
-    0x000E0000,        # 20
+    0x00000000,        # 0.0
+    0x00010000,        # 1.0
+    0x00020000,        # 1.0
+    0x00030000,        # 3.0
+    0x00040000,        # 4.0
+    0x00040001,        # 4.1
+    0x00040002,        # 4.2
+    0x00040003,        # 4.3
+    0x00040004,        # 4.4
+    0x00050000,        # 5.0
+    0x00060000,        # 6.0
+    0x00070000,        # 7.0
+    0x00080000,        # 8.0
+    0x00090000,        # 9.0
+    0x000A0000,        # A.0
+    0x000B0000,        # B.0
     ]
 
@@ -104,5 +94,5 @@
                   x_width,           # number of bits for x coordinate
                   y_width,           # number of bits for y coordinate
-                  irqs_per_core,     # number or IRQs from XCU to one core 
+                  irqs_per_core,     # number or IRQs from ICU to one core 
                   io_cxy,            # IO cluster identifier
                   boot_cxy,          # boot cluster identifier
@@ -186,5 +176,5 @@
     ################################   add an input IRQ in a device
     def addIrq( self,
-                dstdev,                # destination device (PIC or XCU)
+                dstdev,                # destination device (PIC or ICU)
                 port,                  # input IRQ port index
                 srcdev,                # source device
@@ -192,5 +182,5 @@
                 is_rx = False ):       # I/O operation direction
 
-        assert (dstdev.ptype == 'XCU') or (dstdev.ptype == 'PIC')
+        assert (dstdev.ptype == 'ICU_XCU') or (dstdev.ptype == 'PIC_TSR')
         assert (port < dstdev.arg0)
 
@@ -382,13 +372,8 @@
         ram_size     = 0
 
-        nb_cma       = 0
-        cma_channels = 0
-        cma_base     = 0xFFFFFFFFFFFFFFFF
-        cma_size     = 0
-
-        nb_dma       = 0
-        dma_channels = 0
-        dma_base     = 0xFFFFFFFFFFFFFFFF
-        dma_size     = 0
+        nb_rom       = 0
+        rom_channels = 0
+        rom_base     = 0xFFFFFFFFFFFFFFFF
+        rom_size     = 0
 
         nb_fbf       = 0
@@ -419,15 +404,8 @@
         mmc_size     = 0
 
-        nb_mwr       = 0
-        mwr_channels = 0
-        mwr_base     = 0xFFFFFFFFFFFFFFFF
-        mwr_size     = 0
-        mwr_arg0     = 0
-        mwr_arg1     = 0
-        mwr_arg2     = 0
-        mwr_arg3     = 0
-        use_mwr_gcd  = False
-        use_mwr_dct  = False
-        use_mwr_cpy  = False
+        nb_dma       = 0
+        dma_channels = 0
+        dma_base     = 0xFFFFFFFFFFFFFFFF
+        dma_size     = 0
 
         nb_nic       = 0
@@ -436,4 +414,25 @@
         nic_size     = 0
 
+        nb_sim       = 0
+        sim_channels = 0
+        sim_base     = 0xFFFFFFFFFFFFFFFF
+        sim_size     = 0
+
+        nb_tim       = 0
+        tim_channels = 0
+        tim_base     = 0xFFFFFFFFFFFFFFFF
+        tim_size     = 0
+
+        nb_txt       = 0
+        txt_channels = 0
+        txt_base     = 0xFFFFFFFFFFFFFFFF
+        txt_size     = 0
+
+        nb_icu       = 0
+        icu_channels = 0
+        icu_base     = 0xFFFFFFFFFFFFFFFF
+        icu_size     = 0
+        icu_arg0     = 0
+
         nb_pic       = 0
         pic_channels = 0
@@ -441,34 +440,8 @@
         pic_size     = 0
 
-        nb_rom       = 0
-        rom_channels = 0
-        rom_base     = 0xFFFFFFFFFFFFFFFF
-        rom_size     = 0
-
-        nb_sim       = 0
-        sim_channels = 0
-        sim_base     = 0xFFFFFFFFFFFFFFFF
-        sim_size     = 0
-
-        nb_tim       = 0
-        tim_channels = 0
-        tim_base     = 0xFFFFFFFFFFFFFFFF
-        tim_size     = 0
-
-        nb_tty       = 0
-        tty_channels = 0
-        tty_base     = 0xFFFFFFFFFFFFFFFF
-        tty_size     = 0
-
-        nb_xcu       = 0
-        xcu_channels = 0
-        xcu_base     = 0xFFFFFFFFFFFFFFFF
-        xcu_size     = 0
-        xcu_arg0     = 0
-
-        nb_drom       = 0
-        drom_channels = 0
-        drom_base     = 0xFFFFFFFFFFFFFFFF
-        drom_size     = 0
+        nb_rom        = 0
+        rom_channels  = 0
+        rom_base      = 0xFFFFFFFFFFFFFFFF
+        rom_size      = 0
 
         # get devices attributes
@@ -476,5 +449,5 @@
             for device in cluster.devices:
 
-                if ( device.ptype == 'RAM' ):
+                if ( device.ptype == 'RAM_SCL' ):
                     ram_base     = device.base
                     ram_size     = device.size
@@ -482,17 +455,11 @@
                     nb_ram +=1
                 
-                elif ( device.ptype == 'CMA' ):
-                    cma_base     = device.base
-                    cma_size     = device.size
-                    cma_channels = device.channels
-                    nb_cma +=1
-
-                elif ( device.ptype == 'DMA' ):
-                    dma_base     = device.base
-                    dma_size     = device.size
-                    dma_channels = device.channels
-                    nb_dma +=1
-
-                elif ( device.ptype == 'FBF' ):
+                elif ( device.ptype == 'ROM_SCL' ):
+                    rom_base     = device.base
+                    rom_size     = device.size
+                    rom_channels = device.channels
+                    nb_rom +=1
+
+                elif ( device.ptype == 'FBF_SCL' ):
                     fbf_base     = device.base
                     fbf_size     = device.size
@@ -502,5 +469,5 @@
                     nb_fbf +=1
 
-                elif ( device.ptype == 'IOB' ):
+                elif ( device.ptype == 'IOB_TSR' ):
                     iob_base     = device.base
                     iob_size     = device.size
@@ -532,5 +499,4 @@
                     use_ioc_spi  = True
                     nb_ioc += 1
-
                 elif ( device.ptype == 'IOC_RDK' ):
                     ioc_base     = device.base
@@ -540,5 +506,5 @@
                     nb_ioc += 1
 
-                elif ( device.ptype == 'MMC' ):
+                elif ( device.ptype == 'MMC_TSR' ):
                     mmc_base     = device.base
                     mmc_size     = device.size
@@ -546,54 +512,11 @@
                     nb_mmc +=1
 
-                elif ( device.ptype == 'MWR_GCD' ):
-                    mwr_base     = device.base
-                    mwr_size     = device.size
-                    mwr_channels = device.channels
-                    mwr_arg0     = device.arg0
-                    mwr_arg1     = device.arg1
-                    mwr_arg2     = device.arg2
-                    mwr_arg3     = device.arg3
-                    use_mwr_gcd  = True
-                    nb_mwr +=1
-                elif ( device.ptype == 'MWR_DCT' ):
-                    mwr_base     = device.base
-                    mwr_size     = device.size
-                    mwr_channels = device.channels
-                    mwr_arg0     = device.arg0
-                    mwr_arg1     = device.arg1
-                    mwr_arg2     = device.arg2
-                    mwr_arg3     = device.arg3
-                    use_mwr_dct  = True
-                    nb_mwr +=1
-                elif ( device.ptype == 'MWR_CPY' ):
-                    mwr_base     = device.base
-                    mwr_size     = device.size
-                    mwr_channels = device.channels
-                    mwr_arg0     = device.arg0
-                    mwr_arg1     = device.arg1
-                    mwr_arg2     = device.arg2
-                    mwr_arg3     = device.arg3
-                    use_mwr_cpy  = True
-                    nb_mwr +=1
-
-                elif ( device.ptype == 'ROM' ):
-                    rom_base     = device.base
-                    rom_size     = device.size
-                    rom_channels = device.channels
-                    nb_rom +=1
-
-                elif ( device.ptype == 'DROM' ):
-                    drom_base     = device.base 
-                    drom_size     = device.size
-                    drom_channels = device.channels
-                    nb_drom +=1
-
-                elif ( device.ptype == 'SIM' ):
-                    sim_base     = device.base
-                    sim_size     = device.size
-                    sim_channels = device.channels
-                    nb_sim +=1
-
-                elif ( device.ptype == 'NIC' ):
+                elif ( device.ptype == 'DMA_SCL' ):
+                    dma_base     = device.base
+                    dma_size     = device.size
+                    dma_channels = device.channels
+                    nb_dma +=1
+
+                elif ( device.ptype == 'NIC_CBF' ):
                     nic_base     = device.base
                     nic_size     = device.size
@@ -601,39 +524,31 @@
                     nb_nic +=1
 
-                elif ( device.ptype == 'PIC' ):
+                elif ( device.ptype == 'TIM_SCL' ):
+                    tim_base     = device.pseg.base
+                    tim_size     = device.pseg.size
+                    tim_channels = device.channels
+                    nb_tim +=1
+
+                elif ( device.ptype == 'TXT_TTY' ):
+                    txt_base     = device.base
+                    txt_size     = device.size
+                    txt_channels = device.channels
+                    nb_txt +=1
+
+                elif ( device.ptype == 'ICU_XCU' ):
+                    icu_base     = device.base
+                    icu_size     = device.size
+                    icu_channels = device.channels
+                    icu_arg0     = device.arg0
+                    icu_arg1     = device.arg1
+                    icu_arg2     = device.arg2
+                    icu_arg3     = device.arg3
+                    nb_icu +=1
+
+                elif ( device.ptype == 'PIC_TSR' ):
                     pic_base     = device.base
                     pic_size     = device.size
                     pic_channels = device.channels
                     nb_pic +=1
-
-                elif ( device.ptype == 'TIM' ):
-                    tim_base     = device.pseg.base
-                    tim_size     = device.pseg.size
-                    tim_channels = device.channels
-                    nb_tim +=1
-
-                elif ( device.ptype == 'TTY' ):
-                    tty_base     = device.base
-                    tty_size     = device.size
-                    tty_channels = device.channels
-                    nb_tty +=1
-
-                elif ( device.ptype == 'XCU' ):
-                    xcu_base     = device.base
-                    xcu_size     = device.size
-                    xcu_channels = device.channels
-                    xcu_arg0     = device.arg0
-                    xcu_arg1     = device.arg1
-                    xcu_arg2     = device.arg2
-                    nb_xcu +=1
-
-        # no more than two access to external devices
-        assert ( nb_fbf <= 2 )
-        assert ( nb_cma <= 2 )
-        assert ( nb_ioc <= 2 )
-        assert ( nb_nic <= 2 )
-        assert ( nb_tim <= 2 )
-        assert ( nb_tty <= 2 )
-        assert ( nb_pic <= 2 )
 
         # one and only one IOC controller
@@ -647,11 +562,4 @@
             rdk_base = 0
             rdk_size = 0
-
-        # only one type of MWR controller
-        nb_mwr_types = 0
-        if use_mwr_gcd:       nb_mwr_types += 1
-        if use_mwr_dct:       nb_mwr_types += 1
-        if use_mwr_cpy:       nb_mwr_types += 1
-        if ( nb_mwr > 0 ) : assert ( nb_mwr_types == 1 )
 
         # Compute total number of cores, devices and irqs
@@ -697,18 +605,15 @@
         s += '/* Peripherals */\n'
         s += '\n'
-        s += '#define NB_TTY_CHANNELS        %d\n'    % tty_channels
+        s += '#define NB_TXT_CHANNELS        %d\n'    % txt_channels
         s += '#define NB_IOC_CHANNELS        %d\n'    % ioc_channels
         s += '#define NB_NIC_CHANNELS        %d\n'    % nic_channels
-        s += '#define NB_CMA_CHANNELS        %d\n'    % cma_channels
         s += '#define NB_TIM_CHANNELS        %d\n'    % tim_channels
-        s += '#define NB_DMA_CHANNELS        %d\n'    % dma_channels
-        s += '\n'
-        s += '#define USE_XCU                %d\n'    % ( nb_xcu != 0 )
-        s += '#define USE_DMA                %d\n'    % ( nb_dma != 0 )
-        s += '\n'
+        s += '\n'
+        s += '#define USE_ICU                %d\n'    % ( nb_icu != 0 )
         s += '#define USE_IOB                %d\n'    % ( nb_iob != 0 )
         s += '#define USE_PIC                %d\n'    % ( nb_pic != 0 )
         s += '#define USE_FBF                %d\n'    % ( nb_fbf != 0 )
         s += '#define USE_NIC                %d\n'    % ( nb_nic != 0 )
+        s += '#define USE_DMA                %d\n'    % ( nb_dma != 0 )
         s += '\n'
         s += '#define USE_IOC_BDV            %d\n'    % use_ioc_bdv
@@ -718,20 +623,11 @@
         s += '#define USE_IOC_RDK            %d\n'    % use_ioc_rdk
         s += '\n'
-        s += '#define USE_MWR_GCD            %d\n'    % use_mwr_gcd
-        s += '#define USE_MWR_DCT            %d\n'    % use_mwr_dct
-        s += '#define USE_MWR_CPY            %d\n'    % use_mwr_cpy
-        s += '\n'
         s += '#define FBUF_X_SIZE            %d\n'    % fbf_arg0
         s += '#define FBUF_Y_SIZE            %d\n'    % fbf_arg1
         s += '\n'
-        s += '#define XCU_NB_HWI             %d\n'    % xcu_arg0
-        s += '#define XCU_NB_PTI             %d\n'    % xcu_arg1
-        s += '#define XCU_NB_WTI             %d\n'    % xcu_arg2
-        s += '#define XCU_NB_OUT             %d\n'    % xcu_channels
-        s += '\n'
-        s += '#define MWR_TO_COPROC          %d\n'    % mwr_arg0
-        s += '#define MWR_FROM_COPROC        %d\n'    % mwr_arg1
-        s += '#define MWR_CONFIG             %d\n'    % mwr_arg2
-        s += '#define MWR_STATUS             %d\n'    % mwr_arg3
+        s += '#define ICU_NB_HWI             %d\n'    % icu_arg0
+        s += '#define ICU_NB_PTI             %d\n'    % icu_arg1
+        s += '#define ICU_NB_WTI             %d\n'    % icu_arg2
+        s += '#define ICU_NB_OUT             %d\n'    % icu_arg3
         s += '\n'
 
@@ -741,25 +637,19 @@
         s += '#define SEG_RAM_SIZE           0x%x\n'  % ram_size
         s += '\n'
-        s += '#define SEG_CMA_BASE           0x%x\n'  % (cma_base & local_physical_mask)
-        s += '#define SEG_CMA_SIZE           0x%x\n'  % cma_size
+        s += '#define SEG_FBF_BASE           0x%x\n'  % (fbf_base & local_physical_mask)
+        s += '#define SEG_FBF_SIZE           0x%x\n'  % fbf_size
+        s += '\n'
+        s += '#define SEG_IOB_BASE           0x%x\n'  % (iob_base & local_physical_mask)
+        s += '#define SEG_IOB_SIZE           0x%x\n'  % iob_size
+        s += '\n'
+        s += '#define SEG_IOC_BASE           0x%x\n'  % (ioc_base & local_physical_mask)
+        s += '#define SEG_IOC_SIZE           0x%x\n'  % ioc_size
+        s += '\n'
+        s += '#define SEG_MMC_BASE           0x%x\n'  % (mmc_base & local_physical_mask)
+        s += '#define SEG_MMC_SIZE           0x%x\n'  % mmc_size
         s += '\n'
         s += '#define SEG_DMA_BASE           0x%x\n'  % (dma_base & local_physical_mask)
         s += '#define SEG_DMA_SIZE           0x%x\n'  % dma_size
         s += '\n'
-        s += '#define SEG_FBF_BASE           0x%x\n'  % (fbf_base & local_physical_mask)
-        s += '#define SEG_FBF_SIZE           0x%x\n'  % fbf_size
-        s += '\n'
-        s += '#define SEG_IOB_BASE           0x%x\n'  % (iob_base & local_physical_mask)
-        s += '#define SEG_IOB_SIZE           0x%x\n'  % iob_size
-        s += '\n'
-        s += '#define SEG_IOC_BASE           0x%x\n'  % (ioc_base & local_physical_mask)
-        s += '#define SEG_IOC_SIZE           0x%x\n'  % ioc_size
-        s += '\n'
-        s += '#define SEG_MMC_BASE           0x%x\n'  % (mmc_base & local_physical_mask)
-        s += '#define SEG_MMC_SIZE           0x%x\n'  % mmc_size
-        s += '\n'
-        s += '#define SEG_MWR_BASE           0x%x\n'  % (mwr_base & local_physical_mask)
-        s += '#define SEG_MWR_SIZE           0x%x\n'  % mwr_size
-        s += '\n'
         s += '#define SEG_ROM_BASE           0x%x\n'  % (rom_base & local_physical_mask)
         s += '#define SEG_ROM_SIZE           0x%x\n'  % rom_size
@@ -777,15 +667,12 @@
         s += '#define SEG_TIM_SIZE           0x%x\n'  % tim_size
         s += '\n'
-        s += '#define SEG_TTY_BASE           0x%x\n'  % (tty_base & local_physical_mask)
-        s += '#define SEG_TTY_SIZE           0x%x\n'  % tty_size
-        s += '\n'
-        s += '#define SEG_XCU_BASE           0x%x\n'  % (xcu_base & local_physical_mask)
-        s += '#define SEG_XCU_SIZE           0x%x\n'  % xcu_size
+        s += '#define SEG_TXT_BASE           0x%x\n'  % (txt_base & local_physical_mask)
+        s += '#define SEG_TXT_SIZE           0x%x\n'  % txt_size
+        s += '\n'
+        s += '#define SEG_ICU_BASE           0x%x\n'  % (icu_base & local_physical_mask)
+        s += '#define SEG_ICU_SIZE           0x%x\n'  % icu_size
         s += '\n'
         s += '#define SEG_RDK_BASE           0x%x\n'  % (rdk_base & local_physical_mask)
         s += '#define SEG_RDK_SIZE           0x%x\n'  % rdk_size
-        s += '\n'
-        s += '#define SEG_DROM_BASE          0x%x\n'  % (drom_base & local_physical_mask)
-        s += '#define SEG_DROM_SIZE          0x%x\n'  % drom_size
         s += '\n'
         s += '#endif\n'
@@ -931,5 +818,5 @@
         self.arg2     = arg2          # optional (semantic depends on ptype)
         self.arg3     = arg3          # optional (semantic depends on ptype)
-        self.irqs     = []            # set of input IRQs (for PIC and XCU only)
+        self.irqs     = []            # set of input IRQs (for PIC and ICU only)
         self.irq_ctrl = None          # interrupt controller for this device
         return
@@ -946,5 +833,5 @@
         s += ' arg2="%d"'                    % self.arg2
         s += ' arg3="%d"'                    % self.arg3
-        if ( (self.ptype == 'PIC') or (self.ptype == 'XCU') ):
+        if ( (self.ptype == 'PIC_TSR') or (self.ptype == 'ICU_XCU') ):
             s += ' >\n'
             for irq in self.irqs: s += irq.xml()
@@ -958,6 +845,6 @@
 
         if ( verbose ):
-            print '*** cbin for device[%d] / type %s' \
-                  % (self.index , self.ptype)
+            print '*** cbin for device[%d] / type = %s / base = %x' \
+                  % (self.index , self.ptype , self.base)
 
         # check index
@@ -985,7 +872,7 @@
 
         byte_stream = bytearray()
-        byte_stream += mapping.int2bytes(4,ptype_id)       # device type
         byte_stream += mapping.int2bytes(8,self.base)      # segment base address
         byte_stream += mapping.int2bytes(8,self.size)      # segment size
+        byte_stream += mapping.int2bytes(4,ptype_id)       # device type
         byte_stream += mapping.int2bytes(4,self.channels)  # number of channels
         byte_stream += mapping.int2bytes(4,self.arg0)      # optionnal arg0
@@ -997,5 +884,4 @@
 
         if ( verbose ):
-            print 'ptype      = %d' %  ptype_id
             print 'base       = %x' %  self.base
             print 'size       = %x' %  self.size
@@ -1034,6 +920,6 @@
 
         if ( verbose ):
-            print '*** cbin for irq[%d] / type = %s' \
-                   % (self.index , self.isrtype)
+            print '*** cbin for irq[%d] / src_dev = %s' \
+                   % (self.port , self.dev.ptype)
 
         # check index
@@ -1041,5 +927,5 @@
             print '[genarch error] in Irq.cbin()'
             print '    irq global index = %d / expected = %d' \
-                       % (self.index,expected)
+                       % (self.index , expected)
             sys.exit(1)
 
Index: trunk/tools/arch_info/arch_info.h
===================================================================
--- trunk/tools/arch_info/arch_info.h	(revision 1)
+++ trunk/tools/arch_info/arch_info.h	(revision 6)
@@ -63,13 +63,13 @@
  * The 16 MSB bits define the functionnal type.
  * The 16 LSB bits define the implementation type.
- * It must be consistent with values defined in file arch_class.py
+ * It must be consistent with values defined in files arch_class.py, and device.*
  ***************************************************************************************/
 
 enum deviceTypes
 {
-    DEV_TYPE_RAM       = 0x00000000,
-    DEV_TYPE_DMA       = 0x00010000,
-    DEV_TYPE_FBF       = 0x00020000,
-    DEV_TYPE_IOB       = 0x00030000,
+    DEV_TYPE_RAM_SCL   = 0x00000000,
+    DEV_TYPE_ROM_SCL   = 0x00010000,
+    DEV_TYPE_FBF_SCL   = 0x00020000,
+    DEV_TYPE_IOB_TSR   = 0x00030000,
     DEV_TYPE_IOC_BDV   = 0x00040000,
     DEV_TYPE_IOC_HBA   = 0x00040001,
@@ -77,16 +77,11 @@
     DEV_TYPE_IOC_SPI   = 0x00040003,
     DEV_TYPE_IOC_RDK   = 0x00040004,
-    DEV_TYPE_MMC       = 0x00050000,
-    DEV_TYPE_MWR_CPY   = 0x00060000,
-    DEV_TYPE_MWR_GCD   = 0x00060001,
-    DEV_TYPE_MWR_DCT   = 0x00060002,
-    DEV_TYPE_NIC       = 0x00070000,
-    DEV_TYPE_ROM       = 0x00080000,
-    DEV_TYPE_SIM       = 0x00090000,
-    DEV_TYPE_TIM       = 0x000A0000,
-    DEV_TYPE_TTY       = 0x000B0000,
-    DEV_TYPE_XCU       = 0x000C0000,
-    DEV_TYPE_PIC       = 0x000D0000,
-    DEV_TYPE_CMA       = 0x000E0000,
+    DEV_TYPE_MMC_TSR   = 0x00050000,
+    DEV_TYPE_DMA_SCL   = 0x00060000,
+    DEV_TYPE_NIC_CBF   = 0x00070000,
+    DEV_TYPE_TIM_SCL   = 0x00080000,
+    DEV_TYPE_TXT_TTY   = 0x00090000,
+    DEV_TYPE_ICU_XCU   = 0x000A0000,
+    DEV_TYPE_PIC_TSR   = 0x000B0000,
 };
 
@@ -143,6 +138,6 @@
 {
     uint32_t    gid;             // core hardware identifier
+    uint16_t    cxy;             // cluster identifier         
     uint16_t    lid;             // core local index in cluster
-    uint16_t    cxy;             // cluster identifier         
 } 
 archinfo_core_t;
@@ -154,7 +149,7 @@
 typedef struct __attribute__((packed))  archinfo_device_s
 {
+    uint64_t    base;            // base address in physical space
+    uint64_t    size;            // channel size (bytes)
     uint32_t    type;            // supported values defined above
-    uint64_t    base;            // base address in physical space
-    uint64_t    size;            // size (bytes)
     uint32_t    channels;        // number of channels
     uint32_t    arg0;            // semantic depends on device type
@@ -162,5 +157,5 @@
     uint32_t    arg2;            // semantic depends on device type
     uint32_t    arg3;            // semantic depends on device type
-    uint32_t    irqs;            // number of input IRQs (for XCU or PIC)
+    uint32_t    irqs;            // number of input IRQs (for ICU or PIC)
     uint32_t    irq_offset;      // global index of first IRQ 
 } 
Index: trunk/tools/arch_info/boot_info.h
===================================================================
--- trunk/tools/arch_info/boot_info.h	(revision 1)
+++ trunk/tools/arch_info/boot_info.h	(revision 6)
@@ -32,5 +32,5 @@
  ********************************************************************************************/
 
-#define BOOT_INFO_SIGNATURE    0xBABEF00D
+#define BOOT_INFO_SIGNATURE    0x12344321
 
 /*********************************************************************************************
@@ -69,7 +69,7 @@
 typedef struct boot_device_s
 {
+    uint64_t    base;                 /*! segment physical base address                     */
+    uint64_t    size;                 /*! channel size (bytes)                              */
     uint32_t    type;                 /*! peripheral type (func | impl)                     */
-    xptr_t      base;                 /*! segment global base address                       */
-    uint64_t    size;                 /*! channel size (bytes)                              */
     uint32_t    channels;             /*! number of channels                                */
     uint32_t    param0;               /*! semantic depends on peripherat type               */
@@ -90,31 +90,36 @@
 typedef struct boot_info_s
 {
-    uint32_t      signature;         /*! boot info signature                                */
+    uint32_t      signature;                     /*! boot info signature                    */
 
     // global platform parameters
 
-	uint32_t      paddr_width;        /*! number of bits in physical address                */
-    uint32_t      x_width;            /*! number of bits to code X coordinate               */
-    uint32_t      y_width;            /*! number of bits to code Y coordinate               */
-	uint32_t      x_size;             /*! number of cluster in a row                        */
-	uint32_t      y_size;             /*! number of cluster in a column                     */
-	uint32_t      io_cxy;             /*! IO cluster identifier                             */
+	uint32_t      paddr_width;                   /*! number of bits in physical address     */
+    uint32_t      x_width;                       /*! number of bits to code X coordinate    */
+    uint32_t      y_width;                       /*! number of bits to code Y coordinate    */
+	uint32_t      x_size;                        /*! number of cluster in a row             */
+	uint32_t      y_size;                        /*! number of cluster in a column          */
+	uint32_t      io_cxy;                        /*! IO cluster identifier                  */
 
-    // specific cluster parameters
+    // shared resources
 
-	uint32_t      cxy;                /*! current cluster identifier                        */
-	uint32_t      cores_nr;           /*! number of cores in current cluster                */
-    boot_core_t   core[CONFIG_MAX_CORES_PER_CLUSTER];   /* array of core descriptors        */  
-	uint32_t      devices_nr;         /*! number of peripherals in current cluster          */
-    boot_device_t dev[CONFIG_MAX_DEVICES_PER_CLUSTER];  /* array of device descriptors      */
-    uint32_t      pages_nr;           /*! total number of 4 Kbytes pages in cluster         */
-    uint32_t      pages_offset;       /*! number of pages already allocated for kernel      */
+    uint32_t      ext_dev_nr;                    /*! number of external peripherals         */
+    boot_device_t ext_dev[CONFIG_MAX_EXT_DEV];   /*! array of external peripherals          */
+
+    // private resources (per cluster)
+
+	uint32_t      cxy;                           /*! cluster identifier                     */
+	uint32_t      cores_nr;                      /*! number of local cores in               */
+    boot_core_t   core[CONFIG_MAX_LOCAL_CORES];  /*! array of core descriptors              */  
+	uint32_t      int_dev_nr;                    /*! number of local peripherals            */
+    boot_device_t int_dev[CONFIG_MAX_INT_DEV];   /*! array of internal peripherals          */
+    uint32_t      pages_nr;                      /*! number of 4 Kbytes pages               */
+    uint32_t      pages_offset;                  /*! number of pages allocated for kernel   */
 
     // kernel segments
 
-    intptr_t      kernel_code_start;  /*! kernel code base address                          */
-    intptr_t      kernel_code_end;    /*! kernel code last address (excluded)               */
-    intptr_t      kernel_data_start;  /*! kernel data base address                          */
-    intptr_t      kernel_data_end;    /*! kernel data last address (excluded)               */
+    intptr_t      kernel_code_start;             /*! kernel code base address               */
+    intptr_t      kernel_code_end;               /*! kernel code last address (excluded)    */
+    intptr_t      kernel_data_start;             /*! kernel data base address               */
+    intptr_t      kernel_data_end;               /*! kernel data last address (excluded)    */
 }
 boot_info_t;
